//
// 
//
//! \file 
//! \author J Vijn
//! \date 20071217 - 20080328
//
/* === NOTES ===
					  bmp16 / sbmp16
	plot			: 100	/ 123
	hline 10-32		: 375	/ 410
	vline 10-32		: 915	/ 955	(with for-loop: 1438. HOLY SHIT!!!)
	hline (16,10)-(32,120)	: 5037	/ 5057

	
	Deinterlace, 128:	1550 -> 1390
	Edge-line: fixed-point is *so* much faster than Bresenham. Like 3x or 4x
	in most cases.
*/

#include <stdlib.h>
#include <string.h>
#include <tonc.h>

#include "all_gfx.h"

// --------------------------------------------------------------------
// TYPES 
// --------------------------------------------------------------------

// --------------------------------------------------------------------
// GLOBALS 
// --------------------------------------------------------------------

// --------------------------------------------------------------------
// FUNCTIONS 
// --------------------------------------------------------------------

//! Returns the clear-mask for the left side of a fill rect.
INLINE u32 chr4_lmask(uint left)
{
	return 0xFFFFFFFFU<<((left&7)*4);
}


//! Returns the clear-mask for the right side of a fill rect.
INLINE u32 chr4_rmask(uint right)
{
	return 0xFFFFFFFFU>>((-right&7)*4);
}

void test_chr4_line()
{
	REG_DISPCNT= DCNT_MODE0 | DCNT_BG0 | DCNT_BG2;

	pal_bg_mem[0]= CLR_WHITE;
	pal_bg_mem[1]= CLR_GREEN;
	pal_bg_mem[2]= CLR_CYAN;
	pal_bg_mem[3]= CLR_RED;
	pal_bg_mem[4]= CLR_YELLOW;	
	pal_bg_mem[5]= CLR_BLUE;
	pal_bg_mem[6]= CLR_WHITE;
	pal_bg_mem[7]= CLR_MAG;
	pal_bg_mem[8]= CLR_GRAY;

	irq_init(NULL);
	irq_add(II_VBLANK, NULL);

	tte_init_se(0, BG_CBB(3) | BG_SBB(30), 0, CLR_BLUE, 4, NULL, NULL);
	tte_init_con();

	REG_BG2CNT= BG_CBB(0) | BG_SBB(31);

	TSurface srf;
	srf_init(&srf, SRF_CHR4, tile_mem[0], 240, 160, 4, NULL);

	schr4_prep_map(&srf, se_mem[31], 0);

	VBlankIntrWait();
	
	int x0=0, y0=0;
	int x=121, y= 80;

	schr4_frame(&srf, 8, 8, 16, 16, 1);

	while(1)
	{
		VBlankIntrWait();
		key_poll();

		schr4_plot(&srf, x, y, 0);

		if(key_held(KEY_A))
			schr4_rect(&srf, x0, y0, x, y, 0);

		x += key_tri_horz();
		y += key_tri_vert();

		if(key_hit(KEY_A))
		{
			x0= x;
			y0= y;
		}
		if(key_is_down(KEY_A))
			schr4_rect(&srf, x0, y0, x, y, 8);

		schr4_plot(&srf, x, y, 2);
		tte_printf("#{P:8,152}%3d, %3d - %3d %3d", x0, y0, x, y);
	}
}

int main()
{
	irq_init(NULL);
	irq_add(II_VBLANK, NULL);

	test_chr4_line();

	while(1)
		VBlankIntrWait();

	return 0;
}

// EOF
